import 'dart:convert';
import 'dart:developer';
import 'dart:collection';
import 'dart:developer';

import 'package:easynetflutter/easynet/log/Logger.dart';
import 'package:shared_preferences/shared_preferences.dart';

class SessionDataBase {
  static String _SESSION_LIST_NAMES="_SESSION_LIST_NAMES";
  static Logger logger = Logger(className: "SessionDataBase");
  //static Map<String, String> mapSessionName = Map();
  static List<String> mapSessionName = List();

  static SharedPreferences getSharedPreferences() {
    SharedPreferences prefs;
    SharedPreferences.getInstance().then((value) => prefs = value)
        .whenComplete(() {

      return prefs;
    });
  }

  static clearSession()  {
    logger.w("ClearSession: Removendo ${mapSessionName.length} objetos.");
    if (mapSessionName !=  null && mapSessionName.length > 0) {
      //mapSessionName.forEach((k,v) => removeObject(k));
      mapSessionName.forEach((k) => removeObjectMap(k));
      //mapSessionName.forEach((k,v) => logger.w("Excluindo ${k}"));
      mapSessionName.clear();
    }
  }

  static List<String> getMapSession() {
    SharedPreferences prefs = getSharedPreferences();
    return prefs.getStringList(_SESSION_LIST_NAMES);
//    SharedPreferences.getInstance().then((value) => prefs = value)
//        .whenComplete(() {
//      List<String> list = prefs.getStringList(_SESSION_LIST_NAMES);
//      return list;
//    });

    //SharedPreferences prefs = await SharedPreferences.getInstance();
    //List<String> list = prefs.getStringList(_SESSION_LIST_NAMES);

    //return list == null?List(): list;
  }

  static void loadMapSession(){
    mapSessionName = getMapSession();
    //getMapSession().then((value) => mapSessionName = value);
    //mapSessionName = await getMapSession();
  }

  static void saveListSessionNames(String sessionName, List<String> value)  {
    SharedPreferences prefs = getSharedPreferences();
    prefs.setStringList(sessionName, value);
    saveMapSession(sessionName);
//    SharedPreferences.getInstance().then((value) => prefs = value)
//        .whenComplete(() {
//
//      prefs.setStringList(sessionName, value);
//      saveMapSession(sessionName);
//    });
    //SharedPreferences prefs = await SharedPreferences.getInstance();
    //prefs.setStringList(sessionName, value);
    //saveMapSession(sessionName);
  }

  static void saveMapSession(String sessionName) {
    loadMapSession();
    if (sessionName != null && sessionName.trim().length > 0 && !mapSessionName.contains(sessionName)) {
      logger.w("Salvando o nome da Sessao ${sessionName}");
      //Map<String, String> newEntry = {sessionName: sessionName};
      mapSessionName.add(sessionName);
      saveListSessionNames(_SESSION_LIST_NAMES, mapSessionName);
    }
  }

  static void removeMapSession(String sessionName)  {
    loadMapSession();
    mapSessionName.remove(sessionName);
  }

  static String getObject(String sessionName) {
    SharedPreferences prefs = getSharedPreferences();//await SharedPreferences.getInstance();
    String data = prefs.getString(sessionName);
    if (data != null) {
      logger.w("obtendo objeto $sessionName : $data ");
      return data;
    } else {
      return null;
    }
  }

  static removeObjectMap(String sessionName)  {
    SharedPreferences prefs = getSharedPreferences();
    prefs.remove(sessionName);
//    SharedPreferences.getInstance().then((value) => prefs = value)
//    .whenComplete(() {
//      prefs.remove(sessionName);
//      logger.w("removendo objeto interno $sessionName");
//    });

    // = await SharedPreferences.getInstance();
    //prefs.remove(sessionName);
    //logger.w("removendo objeto interno $sessionName");
  }

  static removeObject(String sessionName)  {
    SharedPreferences prefs = getSharedPreferences();
    prefs.remove(sessionName);
    logger.w("removendo objeto $sessionName");
    removeMapSession(sessionName);
  }

  static void saveOject(Object value, String sessionName)  {
    SharedPreferences prefs = getSharedPreferences();
    String jsonStr = jsonEncode(value);
    prefs.setString(sessionName, jsonStr);
    saveMapSession(sessionName);
    logger.w("salvando objeto $value " + value.toString());
  }

  static void saveString(String sessionName, String value) {
    SharedPreferences prefs = getSharedPreferences();
    prefs.setString(sessionName, value);
    saveMapSession(sessionName);
  }

  static void saveInt(String sessionName, int value)  {
    SharedPreferences prefs = getSharedPreferences();
    prefs.setInt(sessionName, value);
    saveMapSession(sessionName);
  }

  static void saveBool(String sessionName, bool value)  {
    SharedPreferences prefs = getSharedPreferences();
    prefs.setBool(sessionName, value);
    saveMapSession(sessionName);
  }

  static void saveDouble(String sessionName, double value) {
    SharedPreferences prefs = getSharedPreferences();
    prefs.setDouble(sessionName, value);
    saveMapSession(sessionName);
  }

  static void saveListString(String sessionName, List<String> value)  {
    SharedPreferences prefs = getSharedPreferences();
    prefs.setStringList(sessionName, value);
    saveMapSession(sessionName);
  }
}